/**
 * cargar la informacion del contenido de codigo de barras
 * @param boolean directo si viene dada a true entonces directamente sacamos la camara para leer el codigo de barras 
 */
cargarContenidoCodigoBarras = function(jq,directo){
	cargarLocalTips();
	var preferencias = st.obtenerLocalVar("preferencias");
	if(preferencias){
		var preferencias = nbf.parseJSON(preferencias);
	}
	var html ='<div class="bloqueCodigoBarras">'+
			  '		<div class="posicionBoton">';
	    html += ui.botonHtml('seccionCodigoBarras scan','Escanear Cdigo de Barras',null,true);
	if(preferencias.botones.codigoBarrasManualSi==1)
		html += ui.botonHtml('seccionCodigoBarras scanManual','Escanear Cdigo de Barras MANUAL SI',null,true);
	
	if(preferencias.botones.codigoBarrasManualNo==1)
		html += ui.botonHtml('seccionCodigoBarras scanManualNO','Escanear Cdigo de Barras MANUAL NO',null,true);
	html+=		'</div>';
	html+='		<div class="posicionTexto">'+
			  '			<span class="resultScan"></span>'+
			  '		</div>'+
			  '		<div class="producto noActivo">nombre de producto </div>'+
			  '</div>';

	jq.html(html);
	$("#content").removeClass("directo");
	
	
	//si tenemos un codigo codificado lo pintamos directamente
	var clasP = $(".contentPrincipal").attr("class").split(" ");
	var cod = clasP[2];
	if(cod)
		buscarEAN(jq,nbf.decodificarDatoClass(cod));
	breadCrumbs.initBreadCrumb("breadCrumbPrincipal");
	breadCrumbs.anadirElemento("breadCrumbPrincipal","codigoBarras","Cdigo de Barras","Lector de cdigo de barras");
	breadCrumbs.pintarBreadCrumb("breadCrumbPrincipal");
	if(directo=="true"){
		if(st.obtenerLocalVar("SOVersion")!="pcVersion")
			scanCode(jq);
		
	}
		

	//Evento que lanza el escaneo desde el dispositivo
	jq.find(".scan").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			scanCode(jq);
		}
	);
	//Evento que lanza el escaneo Manual para pruebas con una referencia que si existe en la bbdd
	jq.find(".scanManual").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var codigo = "8426027168202";
			$(".contentPrincipal").addClass(nbf.codificarDatoClass(codigo));
			buscarEAN(
				jq,
				codigo,
				function(){
					var url =$(".producto").find(".urlFicha").html();
					codigoBarrasEventos(jq);
					contenido.cargarPanelCentral();
				}
			);
		}
	);

	codigoBarrasEventos=function(jq){
		jq.find(".producto img,.producto .name,.producto .brand,.producto .vol,.producto .dist").click(
			function(ev){
				var producto =$(this).closest(".producto");
				if(producto.hasClass("on")){
					producto.removeClass("on");
					producto.find(".urlFicha").html(producto.find(".imgProd").attr("src"));
					producto.find(".imgProd").attr("src",url);
				}
				else{
					producto.addClass("on");
					producto.find(".urlFicha").html(producto.find(".imgProd").attr("src"));
					producto.find(".imgProd").attr("src",url);
					producto.find(".imgProd").attr("width","100px");
				}
			}
		);
		
	}

	//Evento que lanza un escaneo Manual para pruebas con una referencia que no existe en la bbdd
	jq.find(".scanManualNO").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var codigo ="39394";
			buscarEAN(jq,codigo);
		}
	);

	//Evento para aadir a la cesta 
	jq.find(".codigoBarrasAnadirCesta").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			
			var codigo = jq.find("input[name=resultadoScan]");
			if(codigo.val()!=""){
				alert("consultamos el producto en la base de datos");
			}
			else{
				alert("por favor seleccione el codigo de barras");
			}
		}
	);
}

cargarLocalTips=function(){
//	var mensaje = "Busca productos a travs del lector de cdigos de barras."+
//	"Tan solo pulsa en el botn de escanear y acerca tu dispositivo " +
//	"al cdigo de barras de un producto que necesites, y nosotros lo buscaremos por t.<br/><center><img src='img/codigobarras.jpg' /></center>";
	
	var mensaje ="Esta funcin te permite encontrar fcilmente productos leyendo su cdigo de barras. "+
	"Tan slo pulsa en el botn de escanear y acerca tu dispositivo, en un ambiente  con luz, "+
	"al cdigo de barras de un producto y nosotros lo buscaremos por ti.<br/><center><img src='img/codigobarras.jpg' /></center>";
	
	localTips.cargarLocalTips(
			"contentPrincipal codigoBarras",
			1,
			mensaje,
			"Cdigo de barras"
		);
}

/**
 * Funcion que lanza el evento del dispositivo de barcode Scanner
 */
var scanCode = function(jq) {
	   var scanner = cordova.require("cordova/plugin/BarcodeScanner");
       scanner.scan( function (result) { 
		  var codigo =result.text;
		  var clasP = $(".contentPrincipal").attr("class").split(" ");
			if(clasP.length==2)
				$(".contentPrincipal").addClass(nbf.codificarDatoClass(codigo));
			else
				contenido.cambiarClass($(".contentPrincipal"),nbf.codificarDatoClass(codigo));
		
			buscarEAN(
  				jq,
  				codigo,
  				function(){
  					var url =$(".producto").find(".urlFicha").html();
  					codigoBarrasEventos(jq);
  				}
			);
       }, function (error) { 
           console.log("Scanning failed: ", error); 
       } );
}

/**
 * Metodo ajax que busca en la bbdd el codigo de barras leido por el dispositivo
 */
buscarEAN = function(jq,codigo,funcionOK){
	nbf.ejecutar(
		"\\appv1\\app::ajaxBuscarEAN",
		[codigo],
		function(respuesta){
			if(respuesta.status=="ok"){
				$(".bloqueCodigoBarras .producto").removeClass("noActivo");
				$(".bloqueCodigoBarras .producto").html(respuesta.html);
				var clasP = $(".contentPrincipal").attr("class").split(" ");
				if(clasP.length==2)
					$(".contentPrincipal").addClass(nbf.codificarDatoClass(codigo));
				else
					contenido.cambiarClass($(".contentPrincipal"),nbf.codificarDatoClass(codigo));
				cargarEventosProducto(jq,codigo);
				if(funcionOK){
					funcionOK();
				}
			}
			else{
				$(".bloqueCodigoBarras .producto").removeClass("noActivo");
			}
		}
	);
}

cargarEventosProducto = function(jq,codigo){
	jq.find(".producto .btnMas").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var item = $(this).closest(".producto");
			if(item.find(".btnMenos").size()>0){
				carro.anadirUnidadCarro(item,
					function(ev){
						//ui.actualizarCarro();
						//contenido.cambiarClass($(".contentPrincipal"),nbf.codificarDatoClass(codigo));
						$("#content").removeClass("directo");
						contenido.cargarPanelCentral();
					}
				);
			}
			else{
				carro.anadirUnidadCarro(
					item,
					function (ev){
						buscarEAN(jq,codigo);
						//ui.actualizarCarro();
						$("#content").removeClass("directo");
						contenido.cargarPanelCentral();
					},true
				);
			}
		}
	);
		
	/**
	 * Boton quitar una unidad de articulos de la cesta
	 */
	jq.find(".producto .btnMenos").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var item = $(this).closest(".producto");
			carro.quitarUnidadCarro(
					item,
					false,
					function(){
						contenido.cargarPanelCentral();
					}
			);
			//ui.actualizarCarro();
			
			//contenido.cargarPanelCentral();
		}
	);
		
	/**
	 * Boton de eliminar el producto de la cesta
	 */
	jq.find(".producto .btnEliminar").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			if(confirm("Ests seguro que quieres eliminar el producto del carro?"))
				carro.eliminarProductoCarro(nbf.extraerDatos($(this).closest(".producto")));
			$("#content").removeClass("directo");
			contenido.cargarPanelCentral();
		}
	);
		
	/**
	 * Boton para reservar las super-ofertas
	 */
	jq.find(".producto .btnReservar").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var jqOfer = $(this).closest(".itemOfertaFlash");
			if(jqOfer.hasClass("agotada")==false){
				so.reservarOfertaFlash(nbf.extraerDatos(jqOfer),$(this),jqOfer);
				ui.actualizarCarro();
			}
		}
	);
		
	/**
	 * Boton para reservar una unidad mas de super-ofertas
	 */
	jq.find(".producto .btnReservarMas").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var jqOfer = $(this).closest(".itemOfertaFlash");
			if(jqOfer.hasClass("agotada")==false){
				so.reservarOfertaFlash(nbf.extraerDatos(jqOfer),$(this),jqOfer,null,1);
				ui.actualizarCarro();
			}
		}
	);
	/**
	 * Boton para reservar las super-ofertas
	 */
	jq.find(".producto .btnReservarMenos").click(
		function(ev){
			ev.preventDefault();
			ev.stopPropagation();
			var jqOfer = $(this).closest(".itemOfertaFlash");
			if(jqOfer.hasClass("agotada")==false){
				so.reservarOfertaFlash(nbf.extraerDatos(jqOfer),$(this),jqOfer,null,-1);
				ui.actualizarCarro();
			}
		}
	);

	
}
