
/**
 * Carga de la pagina de mis datos
 */
cargarMisDatos =function(jq,funcionDespues){
	nbf.ejecutar(
		"\\appv1\\app::ajaxObtenerMisDatos",
		[],
		function (respuesta){
			if(respuesta.status=='ok'){
				$(".bloqueDerecho .contenidoInformacion").html(respuesta.html);
				breadCrumbs.initBreadCrumb("breadCrumbDerecho");
				breadCrumbs.anadirElemento("breadCrumbDerecho","misDatos","Mis Datos");
				breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
				if(funcionDespues)
					funcionDespues();
				cargarMisDatosEventos();
				
			}
		}
	);
	cargarMisDatosEventos = function(){
		var linkFB = jq.find(".fsRedes .perfilFb .lnkPerfil a");
		if(linkFB.size()>0){
			linkFB.attr("href","#");
		}
		var modEdicionDatos = jq.find(".modEdicionDatosUsuario");
		if(modEdicionDatos.size()>0){
			//mostrar/ocultar fieldsets
			modEdicionDatos.find("fieldset .titF").click(
				function(ev){
					ev.preventDefault();
					var fs = $(this).closest("fieldset");
					var campos = fs.find(".campo");
					if(fs.hasClass("fsAbierto")){
						campos.slideUp(
							500,
							function(){
								fs.removeClass("fsAbierto");
							}
						);
					}else{
						var fAbrir = function(){
							campos.slideDown(500);
							modEdicionDatos.find(".fsAbierto").removeClass("fsAbierto");
							fs.addClass("fsAbierto");
						};
						
						var camposAbiertos = modEdicionDatos.find(".fsAbierto .campo");
						if(camposAbiertos.size()>0)
							camposAbiertos.slideUp(500,fAbrir);
						else
							fAbrir();
					}
				}
			);
		}
		jq.find(".fsEsEmpresa .btnSubmitEsEmpresa,.btnSubmitEsParticular").click(
			function(ev){
				ev.preventDefault();
				usuario.cambiarEsEmpresa(
					$(this).hasClass("btnSubmitEsEmpresa"),
					function(){
						window.location.reload();
					},
					function(mensajes){
						ui.popup.crearAlertaError(mensajes,null,"Error en el cambio");
					}
				);
			}
		);
		
		jq.find(".fsAcceso .btnSubmitEmail").click(
			function(ev){
				ev.preventDefault();
				usuario.cambiarEmail(
					modEdicionDatos.find(".campoNuevoEmail input").val(),
					modEdicionDatos.find(".campoNuevoEmailConfirmar input").val(),
					function(){
						ui.popup.crearAlertaOk("Los datos han sido modificados correctamente",null,"Cambio realizado");
					},
					function(mensajes){
						ui.popup.crearAlertaError(mensajes,null,"Error en el cambio");
					}
				);
			}
		);
		jq.find(".fsRedes .btnDesvincularFb").click(
			function(ev){
				ev.preventDefault();
				ui.popup.crearConfirmar(
					"Quieres desvincular tu cuenta de facebook de este usuario?",

					function(){
						nbf.ejecutar(
							"\\appv1\\app::ajaxDesvincularCuentaFb",
							[],
							function(respuesta){
								contenido.cargarBloqueDerecho();
							}
						);
					},
					null,
					false,
					"Desvincular cuenta"
				);
			}
		);
		
		jq.find(".fsRedes .btnVincularFb").click(
			function(ev){
				ev.preventDefault();
				ui.popup.crearConfirmar(
					"Quieres vincular este usuario con tu cuenta de Facebook?",
					function(){
						
						facebook.init(
							true,
							function(respuesta){
								contenido.cargarBloqueDerecho();
							},
							function(){
								ui.popup.crearAlertaError("Los datos introducidos no son correctos",null,"Error en datos");
							}
						);
					},
					null,
					false,
					"Vincular cuenta"
				);
			}
		);
		jq.find(".fsAcceso .btnSubmitPass").click(
			function(ev){
				ev.preventDefault();
				
				var passAnterior= modEdicionDatos.find(".campoAnteriorPass input");
				var pass1 = modEdicionDatos.find(".campoNuevoPass input");
				var pass2 = modEdicionDatos.find(".campoNuevoPassConfirmar input");
				usuario.cambiarPass(
					passAnterior.val(),
					pass1.val(),
					pass2.val(),
					function(){
						ui.popup.crearAlertaOk(nbf.txt.v("CAMBIAR_PASS_OK"),null,"Cambio realizado");
						passAnterior.val("");
						pass1.val("");
						pass2.val("");
					},
					function(mensajes){
						ui.popup.crearAlertaError(mensajes,null,"Error contrasea");
					}
				);
			}
		);
		jq.find(".fsPrefs .btnSubmit").click(
			function(ev){
				ev.preventDefault();
				var btn = $(this);
				var formu = btn.closest("form");
				nbf.ejecutar(
					"\\appv1\\app::ajaxCambiarPreferencias",
					[ui.form.obtenerValores(formu)],
					function(respuesta){
						if(respuesta.status=="ok")
							ui.popup.crearAlertaOk("Preferencias cambiadas correctamente",null,"Preferencias");
						else
							ui.popup.crearAlertaError(respuesta.mensajes,null,"Error en preferencias");
					}
				);
			}
		);
		jq.find(".fsParticular .btnSubmit,.fsEmpresa .btnSubmit,.fsFacturacion .btnSubmit").click(
			function(ev){
				var btn = $(this);
				var formu = btn.closest("form");
				usuario.cambiarDatosPersonales(
					formu.find(".fsEmpresa").size()>0,
					formu.serializeArray(),
					function(){
						ui.popup.crearAlertaOk("Los datos han sido actualizados",null,"Datos actualizados");
					},
					function(){
						alert("error");
					}
				);
			}
		);
		jq.find(".radios a").click(
			function(ev){
				ev.preventDefault();
				var radios = $(this).closest(".radios");
				radios.find("a").removeClass("sel");
				$(this).addClass("sel");
				var id = nbf.extraerDatos($(this));
				radios.find("input").val(id);
			}
		);
		//eventos del codigo postal
		ui.codigoPostalLocalidad(jq.find(".codigoPostalLocalidad"));
	}
}

/**
 * Carga de la pagina de mis descuentos
 */
cargarMisDescuentos =function(jq,funcionDespues){
	nbf.ejecutar(
		"\\appv1\\app::ajaxObtenerMisDescuentos",
		[],
		function (respuesta){
			if(respuesta.status=='ok'){
				$(".bloqueDerecho .contenidoInformacion").html(respuesta.html);
				breadCrumbs.initBreadCrumb("breadCrumbDerecho");
				breadCrumbs.anadirElemento("breadCrumbDerecho","misDescuentos","Mis Descuentos");
				breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
				if(funcionDespues)
					funcionDespues();
			}
		}
	);
}

/**
 * Carga de la pagina de mis pedidos
 */
cargarMisPedidos = function(jq,funcionDespues){
	nbf.ejecutar(
		"\\appv1\\app::ajaxObtenerHistoricoPedidos",
		[],
		function (respuesta){
			if(respuesta.status=='ok'){
				$(".bloqueDerecho .contenidoInformacion").html(respuesta.html);
				breadCrumbs.initBreadCrumb("breadCrumbDerecho");
				breadCrumbs.anadirElemento("breadCrumbDerecho","misPedidos","Mis Pedidos");
				breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
				var btnsAlbaranes =$(".bloqueDerecho .contenidoInformacion .btnAlbaran a");
				if(btnsAlbaranes.size()>0){
					btnsAlbaranes.attr("href","#");
				}
				var btnsFacturas = $(".bloqueDerecho .contenidoInformacion .btnFactura a");
				if(btnsFacturas.size()>0){
					btnsFacturas.attr("href","#");
				}
				if(funcionDespues)
					funcionDespues();
				cargarMisPedidosEventos(jq);
			}
		}
	);
	cargarMisPedidosEventos = function (jq){
		$(".modPedidos .btnVerPedido").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				var idPedido = nbf.extraerDatos($(this).closest(".topPedido"));
				contenido.cambiarClass($(".bloqueDerecho"),"miPedidoFicha");
				$(".bloqueDerecho").addClass(nbf.codificarDatoClass(idPedido));
				//breadCrumbs.initBreadCrumb("breadCrumbDerecho");
				//breadCrumbs.anadirElemento("breadCrumbDerecho","miPedidoFicha "+nbf.codificarDatoClass(idPedido),"Ficha de Pedido");
				breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
				contenido.cargarBloqueDerecho(
						function(){
							var comienzo = new Date().getTime();
							ui.popup.iniciarPopupEspera(comienzo);
						},
						function(){
							ui.popup.cerrarPopupEspera();
						}				
					);
			}
		);
		
		$(".btnAlbaran").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				var jqPedido= $(this).closest(".topPedido");
				var idPedido = nbf.extraerDatos(jqPedido);
				
				nbf.ejecutar(
					"\\appv1\\app::ajaxDescargarAlbaran",
					[idPedido],
					function (respuesta){
						     var ref = window.open(respuesta.urlAlbaran, '_system', 'location=no');
					}
				);
			}
		);
		$(".btnFactura").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				var jqPedido=$(this).closest(".topPedido");
				var idPedido = nbf.extraerDatos(jqPedido);
				nbf.ejecutar(
					"\\appv1\\app::ajaxDescargarFactura",
					[idPedido],
					function(respuesta){
					     var ref = window.open(respuesta.urlFactura, '_system', 'location=no');
					}
				);
			}
		);
	
		
		$(".btnAnular").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				var idPedido=nbf.extraerDatos($(this).closest(".topPedido"));
				anularPedido(idPedido);
			}
		);
	}
}

anularPedido = function(idPedido){
	ui.popup.crearConfirmar(
		"Ests seguro que quieres anular este pedido?",
		function(){
			nbf.ejecutar(
				"\\appv1\\app::ajaxAnularPedido",
				[idPedido],
				function (respuesta){
					if(respuesta.status=="ok"){
						ui.popup.crearAlerta("El pedido ha sido anulado correctamente",null,"popup2",false,"Anular pedido");
						$(".bloqueDerecho").attr("class","bloqueDerecho");
						contenido.cargarBloqueDerecho();
					}
				}
			);
		},
		null,
		false,
		"Anular pedido"
	);
}
// funcion que carga la ficha de un pedido
cargarFichaPedido = function(jq,funcionDespues){
	var estilos= $(".bloqueDerecho").attr("class").split(" ");
	var idPedido = nbf.decodificarDatoClass(estilos[2]);
	cargarDetallePedido(jq,idPedido,funcionDespues);
	
}
cargarDetallePedido = function(jq,idPedido,funcionDespues){
	nbf.ejecutar(
		"\\appv1\\app::ajaxObtenerFichaPedido",
		[idPedido],
		function (respuesta){
			if(respuesta.status=='ok'){
				$(".bloqueDerecho .contenidoInformacion").html(respuesta.html);
				var numPedido =$(".top .topAdic div strong").html();
				breadCrumbs.anadirElemento("breadCrumbDerecho","miPedidoFicha "+nbf.codificarDatoClass(idPedido),"Ficha de Pedido"+" "+ numPedido);
				breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
//				$(".breadCrumbs.btnNivel .zpTitulo").text("Ficha de Pedido"+" "+ numPedido);
				cargarDetallePedidoEventos(jq);
				$(".bloqueDerecho .contenidoInformacion").removeClass("cargando");
				if(funcionDespues)
					funcionDespues();
				
			}
		}
	);
	cargarDetallePedidoEventos = function(jq){
		var linkTodosPedidos= $(".btnVerPedidos a");
		//quitamos el href del boton
		if(linkTodosPedidos.size()>0){
			linkTodosPedidos.attr("href","#");
		}
		var linkProductosPedido =$(".linea .des a");
		if(linkProductosPedido.size()>0){
			linkProductosPedido.attr("href","#");
		}
				
		$(".btnVerPedidos").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				$(".bloqueDerecho").attr("class","bloqueDerecho misPedidos");
				contenido.cargarBloqueDerecho(
						function(){
							var comienzo = new Date().getTime();
							ui.popup.iniciarPopupEspera(comienzo);
						},
						function(){
							ui.popup.cerrarPopupEspera();
						}							
					);
			}
		);
		$(".btnAnular").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.vibracionCorta();
				var idPedido=nbf.extraerDatos($(this).closest(".topPedido"));
				anularPedido(idPedido);
			}
		);
		
		$(".btnAddTodos").click(
			function(ev){
				nbf.ejecutar(
					"\\appv1\\app::ajaxIncluirProductosPedido",
					[idPedido],
					function (respuesta){
						if(respuesta.status=='ok'){
							$(".bloqueDerecho .contenidoInformacion").html(respuesta.html);
							$(".bloqueDerecho").removeClass("cargando");
							cargarIncluirProductosEventos();
						}
					}
				);
				cargarIncluirProductosEventos = function(){
					$(".cantMas").click(
						function(ev){
							ev.preventDefault();
							var cant = $(this).closest("div").find(".inputUds").val();
							$(this).closest("div").find(".inputUds").val(parseInt(cant)+1);
						}
					);
					$(".cantMenos").click(
							function(ev){
								ev.preventDefault();
								var cant = $(this).closest("div").find(".inputUds").val();
								if(parseInt(cant)!=0)
									$(this).closest("div").find(".inputUds").val(parseInt(cant)-1);
							}
						);
					$(".conjuntoControles .cancelar").click(
						function(ev){
							ev.preventDefault();
							contenido.cargarBloqueDerecho();
						}
					);
					$(".conjuntoControles .guardar").click(
						function(ev){
							ev.preventDefault();
							var productos = [];
							$(".linea").each(
								function(){
									var unidades = $(this).find(".addOuter .inputUds").val();
									var producto = {};
									producto.idProducto = nbf.extraerDatos($(this));
									producto.cantidad = unidades;
									if(producto.cantidad>0)
										productos.push(producto);
								}
							);
							ui.popup.crearConfirmar(
								"Quieres aadir estos productos al carro?",
								function(){
									nbf.ejecutar(
										"\\appv1\\app::ajaxIncluirProductos",
										[productos],
										function (respuesta){
											if(respuesta.status=='ok'){
												swiper.moverSwiper(0);	
												$(".bloqueDerecho").attr("class","bloqueDerecho");
												contenido.cargarBloqueDerecho();
												contenido.cargarBloqueIzquierdo();
											}
										}
									);
								},
								null,
								false,
								"Aadir al carro"
							);
						}
					);
				}
			}
		);
	}
}

/**
 * ventana de mis recomendados por email
 */
cargarMisRecomendadosEmail =function(jq,funcionDespues) {
		var html ='';
		html +='<p class="msgOk">';
		html +='<strong>';
		html +='Muchas gracias por recomendar Tudespensa.com a tus amigos!';
		html +='<br>';
		html +='<br>';
		html +='</strong>';
		html +='Y recuerda que cuando hagan su primera compra recibirs tu cupn descuento automticamente por cada uno de ellos.';
		html +='<strong>';
		html +='<br>';
		html +='</strong>';
		html +='</p>';
		html +='<form class="formulario formularioRecomendacion">';
		html +='<fieldset class="fs0">';
		html +='<div class="campo campoTextoLargo campoEmails">';	
		html +='<textarea id="emails" class="textoLargo" rows="4" cols="10" name="emails"></textarea>';
		html +='<div class="ayuda"><p>Puedes escribir uno por lnea o separarlos por comas</p>';
		html +='</div>'; 
		html +='</fieldset>';
		html +='<fieldset class="fs1">';
		html +='<div class="campo campoTextoLargo campoMensaje">';	
		html +='<label for="">Personaliza tu mensaje</label>';
		html +='<textarea id="mensaje" class="textoLargo" rows="4" cols="10" name="mensaje">Hola, '+$(".bienvenidoText").html()+' no quiere que vuelvas al supermercado, por eso te ha recomendado para que descubras la compra inteligente.</textarea>';
		html +='</fieldset>';
		html +=ui.botonHtml("button btnEnviarRecomendacion","Enviar Recomendaciones","");
		html +='</form>';
	$(".bloqueDerecho .contenidoInformacion").html(html);
	breadCrumbs.anadirElemento("breadCrumbDerecho","misRecomendadosEmail","Recomendar por email");
	breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
	
	if(funcionDespues)
		funcionDespues();
	cargarMisRecomendadosEmailEventos(jq);
}

cargarMisRecomendadosEmailEventos = function(jq){
	jq.find(".btnEnviarRecomendacion").click(
		function(ev){
			ev.preventDefault();
			var formu = jq.find(".formularioRecomendacion");
			var idModulo =22; //prueba metiendo un modulo
			if(jq.find("textarea[name=emails]").val()!=""){
				valores = ui.form.obtenerValores(formu);
				var comienzo = new Date().getTime();
				ui.popup.iniciarPopupEspera(comienzo);
				ui.usuario.enviarRecomendacion(
					valores,
					idModulo,
					function(){
						ui.popup.crearAlerta(jq.find(".msgOk"),null,"popup2",false,"Recomendados avisados");
						contenido.cambiarClass($(".bloqueDerecho"),"cargandoMisRecomendados");
						contenido.cargarBloqueDerecho();
						ui.popup.cerrarPopupEspera();
						
					},
					function(mensajes){
						ui.popup.crearAlertaError(mensajes,null,"Error en la recomendacin");
					}
				);
			}
			else
				ui.popup.crearAlertaError("Tienes que escribir al menos un email para enviar la recomendacion",null,"Emails no encontrados");
		
		}
	);
}
/**
 * Carga de la pagina de mis recomendados
 */
cargarMisRecomendados =function(jq,funcionDespues){
	nbf.ejecutar(
		"\\appv1\\app::ajaxObtenerMisRecomendados",
		[],
		function (respuesta){
			if(respuesta.status=='ok'){
				var html = respuesta.html;
				html +=	'<div class="mod"><h1 class="h">RECOMENDAR A MAS AMIGOS</h1>';
							
				var botonEmail = ui.botonHtml("secRecEmail","Recomendar ms amigos (Email)",null);
				html +=botonEmail;
				html +='</div>';
				$(".bloqueDerecho .contenidoInformacion").html(html);
				var recomendados =$(".bloqueDerecho .contenidoInformacion .modUsuariosRecomendados .img img");
				recomendados.each(
					function(){
						if($(this).attr("title")==undefined){
							var src=$(this).attr("src");
							src=src.substr(5,src.length);
							$(this).attr("src",src);
						} 
					}
				);
				
				breadCrumbs.initBreadCrumb("breadCrumbDerecho");
				breadCrumbs.anadirElemento("breadCrumbDerecho","misRecomendados","Mis Recomendados");
				breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
				if(funcionDespues)
					funcionDespues();
				
				cargarMisRecomendadosEventos(jq);
			}
		}
	);
}

cargarMisRecomendadosEventos = function(jq){
	jq.find(".secRecEmail").click(
		function(ev){
			ev.preventDefault();
			contenido.cambiarClass($(".bloqueDerecho"),"misRecomendadosEmail");
			contenido.cargarBloqueDerecho(
				function(){
					var comienzo = new Date().getTime();
					ui.popup.iniciarPopupEspera(comienzo);
				},
				function(){
					ui.popup.cerrarPopupEspera();
				}				
			);
		}
	);
	jq.find(".secRecFace").click(
		function(ev){
			ev.preventDefault();
			facebook.enviarMensaje();
		}
	);
	jq.find(".secRecTwitt").click(
		function(ev){
			ev.preventDefault();
			nbf.ejecutar(
				"\\appv1\\app::ajaxObtenerUrlRecomendacionTwitter",
				[idModulo],
				function(url){
					window.plugins.ChildBrowser.showWebPage(url, { showLocationBar: false });
					
				}
			);
		}
	);
}


cargarMisSuperOfertas = function(jq,funcionDespues){
	nbf.ejecutar(
		"\\appv1\\app::ajaxObtenerMisSuperOfertas",
		[],
		function (respuesta){
			if(respuesta.status=="ok"){
				jq.html(respuesta.html);
				//jq.removeClass("cargando");
				breadCrumbs.initBreadCrumb("breadCrumbDerecho");
				breadCrumbs.anadirElemento("breadCrumbDerecho","misSuperOfertas","Mis Super-ofertas reservadas");
				breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
				if(funcionDespues)
					funcionDespues();
			}
		}
	);
}


cargarMiBonoGastos= function(jq,funcionDespues){
	nbf.ejecutar(
		"\\appv1\\app::ajaxObtenerMiBonoGastos",
		[],
		function (respuesta){
			if(respuesta.status=="ok"){
				jq.html(respuesta.html);
				breadCrumbs.initBreadCrumb("breadCrumbDerecho");
				breadCrumbs.anadirElemento("breadCrumbDerecho","miBonoGastos","Bonos Gastos Envo","Mis bonos de Gastos de Envo");
				breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
				if(funcionDespues)
					funcionDespues();
			}
		}
	);
}

cargarMisCuponesP= function(jq,funcionDespues){
	nbf.ejecutar(
		"\\appv1\\app::ajaxObtenerMisCuponesProducto",
		[],
		function (respuesta){
			if(respuesta.status=="ok"){
				jq.html(respuesta.html);
				breadCrumbs.initBreadCrumb("breadCrumbDerecho");
				breadCrumbs.anadirElemento("breadCrumbDerecho","misCUponesP","Mis Cupones","Mis cupones de descuento");
				breadCrumbs.pintarBreadCrumb("breadCrumbDerecho");
				if(funcionDespues)
					funcionDespues();
				cargarEventosCuponesP(jq);
			}
		}
	);
}

cargarEventosCuponesP = function(jq){
	jq.find(".btnCanjear").click(
		function(ev){
			ev.preventDefault();
			var cupon= nbf.extraerDatos($(this));
			carro.cambiarCantidadProductoAJAX(
				cupon.p,
				cupon.c,
				null,
				null,
				null,
				function(){
					contenido.cargarBloqueDerecho();
					ui.actualizarCarro();
				}
			);	
		}
	);
}

cargarTest = function(jq){
	var html ="Cargando informacion ...";
	jq.html(html);
	jq.addClass("cargando");
	contenido.cambiarClass($(".bloqueDerecho"),"testtest");
	contenido.cargarBloqueDerecho(jq);
}

