ui = ui || {};
ui.catalogo = ui.catalogo || {};
ui.catalogo.ficha = function(){
	var izoomAbierto = false;

	//Actualiza el punto de referencia de la imagen de ficha (esquina superior izquierda)
	function actualizarRefImg(img){
		img.data("refImg",img.offset());
	};

	function cargarImagen(jqFichaProducto,urlNormal,urlGrande,funcionOk){
		var img = jqFichaProducto.find(".bloqueMedia .imgProd");
		img.data("urlGrande",urlGrande);
		img.attr("src",urlNormal);
		var fLoad = function(){
			actualizarRefImg($(this));
			if(funcionOk)
				funcionOk();
		};
		
		if(img.get(0).complete)
			fLoad();
		else
			img.load(fLoad);
		
	};

	//inicia el izoom del producto
	function izoomIniciar(cImg){
		var bMedia = cImg.closest(".bloqueMedia");
		var img = cImg.find("img");
		actualizarRefImg(img);
		img.attr("title","");
		if(img.data("urlGrande")){
			var cImgGrande = bMedia.find(".cImgGrande");
			var areaCursor = bMedia.find(".areaCursor");
			var imgGrande = cImgGrande.find("img");
				
			if(cImgGrande.size()==0){
				imgGrande = $("<img />"); 
				cImgGrande = $("<div></div>");
				cImgGrande.addClass("cImgGrande");
				cImgGrande.append(imgGrande);
				bMedia.prepend(cImgGrande);
			}
			
			if(areaCursor.size()==0){
				areaCursor = $("<div />");
				areaCursor.addClass("areaCursor");
				areaCursor.mousemove(
					function(ev){
						ev.stopPropagation();
						izoomActualizar(cImg,ev.pageX,ev.pageY);
					}
				).mouseout(
					function(ev){
						ev.stopPropagation();
					}
				).mouseenter(
					function(ev){
						ev.stopPropagation();
					}
				).click(
					function(){
						img.click();
					}
				);
				bMedia.find(".imgP").append(areaCursor);
			}else
				areaCursor.show();
			areaCursor.fadeTo(0.5);
			cImgGrande.show();
			cImgGrande.addClass("cargando");
			imgGrande.attr("src","");
			imgGrande.attr("src",img.data("urlGrande"));
			imgGrande.load(
				function(){
					cImgGrande.removeClass("cargando");
					img.data("refRatioX",$(this).width()/img.width());
					img.data("refRatioY",$(this).height()/img.height());
					areaCursor.css("width",cImgGrande.width()/img.data("refRatioX"));
					areaCursor.css("height",cImgGrande.height()/img.data("refRatioY"));
				}
			);
			img.css("cursor","crosshair");
			izoomAbierto = true;		
		}else
			img.css("cursor","default");
	}

	//finaliza el izoom del producto
	function izoomFinalizar(cImg){
		if(izoomAbierto){
			var bMedia = cImg.closest(".bloqueMedia"); 
			bMedia.find(".cImgGrande").fadeOut();
			bMedia.find(".areaCursor").hide();
			izoomAbierto = false;
		}
	};

	//actualiza el izoom del producto a la posicin pasada
	function izoomActualizar(cImg,pageX,pageY){
		var bMedia = cImg.closest(".bloqueMedia");
		var cImgGrande = bMedia.find(".cImgGrande");
		var imgGrande = cImgGrande.find("img");
		var img = cImg.find("img");
		var areaCursor = cImg.find(".areaCursor");
		if(img.data("refImg") && img.data("refRatioX")){
			var x = parseInt(pageX-img.data("refImg").left);
			var y = parseInt(pageY-img.data("refImg").top);
			if(x>img.width() || x<0 || y>img.height() || y<0)
				izoomFinalizar(img);
			else{
				areaCursor.offset(
					{
						"left":Math.floor(pageX-areaCursor.width()/2),
						"top":Math.floor(pageY-areaCursor.height()/2)
					}
				);
				imgGrande.css("margin",""+(-y*img.data("refRatioY")+cImgGrande.height()/2)+"px 0px 0px "+(-x*img.data("refRatioX")+cImgGrande.width()/2)+"px");
			}
		}
	}
	
	//Inicializa el control de aadir/modificar cantidad del carro
	function initControlAnadirCarro(jq,jqProducto,funcionCambioCantidad){
		var inputCantidad = jq.find("input");
		//almacenamos cantidad anterior
		inputCantidad.data("cantidad",(!jqProducto || jqProducto.hasClass("itemEnCarro"))?inputCantidad.val():0);
		//aadir/quitar cantidad
		var cant = jq.find(".popupContent .cant");
		cant.click(
			function(ev){
				ev.preventDefault();
				var addOuter = $(this).closest(".addOuter");
				var datos = nbf.extraerDatos(addOuter);
				//mostramos botn de confirmar si estamos editando
				if(addOuter.closest(".itemEnCarro").size()>0)
					addOuter.find(".btnConfirmarEdit").show();
				var input = addOuter.find("input");
				var inc = 1;
				if($(this).hasClass("cantMenos"))
					inc = -1;
				else if($(this).hasClass("cantMasPack")){
					inc = parseInt($(this).text());
					if(input.val()=="1") //si es 1, ponemos el valor del pack
						inc--;
				}
				var val = Math.min(Math.max(parseInt(input.val())+inc,0),999);
				if(datos && datos.l>0)
					val = Math.min(datos.l,val);
				input.val(val);
			}
		);
		
		//aadir al carro cantidad				
		jq.find(".btnConfirmar").click(
			function(ev){
				ev.preventDefault();
				var outer = $(this).closest(".addOuter");
				var datos = nbf.extraerDatos(outer);
				var idProducto = datos.p;
				var idOfertaFlash = null;
				if(datos.o)
					idOfertaFlash = datos.o;
				var input = outer.find("input");
				var cantidad = input.val();
				var cantidadAnterior = input.data("cantidad");
				
				if(cantidad==parseInt(cantidad)){
					carro.cambiarCantidadProductoAJAX(
						idProducto,
						cantidad,
						idOfertaFlash,
						datos.vc?true:false,
						datos.vc?$(".listaCompra .topBusqueda .txt").val():"",
						function(cantidadNueva){
							funcionCambioCantidad(idProducto,cantidadNueva);
							input.data("cantidad",cantidadNueva);
							input.attr("value",cantidadNueva);
							outer.find(".btnConfirmarEdit").hide();
							//ui.pedido.proceso.carro.productoACarro(jqProducto.find(".imgProd").eq(0),cantidadAnterior,cantidadNueva,idProducto);
							
						},
						function(cantidadDisponible){
							if(idOfertaFlash)
								ui.popup.crearAlertaError("Mximo de "+cantidadDisponible+" unidades por carro en esta super-oferta",null,"Lmite super-oferta");
							else
								ui.popup.crearAlertaError("Quedan disponibles "+cantidadDisponible+" unidades en este momento",null,"Unidades disponibles");
						},
						function(mensaje){
							ui.popup.crearAlertaError(mensaje,null,"Error");
						}
					);
					
					jqProducto.find(".popupInner").show();
					jqProducto.find(".carro").hide();
					nbf.lanzar(500,function(){jqProducto.find(".inputUds").val(cantidad);});
					
				}else
					ui.popup.crearAlertaError(respuesta.mensajes,null,"Error");
			}
		);
		
		//quitar del carro				
		jq.find(".btnQuitar").click(
			function(ev){
				ev.preventDefault();
				var outer = $(this).closest(".addOuter");
				var idProducto = nbf.extraerDatos(outer);
				var input = outer.find("input");
				var cantidadAnterior = input.data("cantidad");
				
				pedido.proceso.carro.eliminarProducto(
					idProducto,
					false,
					function(){
						funcionCambioCantidad(idProducto,0);
						input.data("cantidad",0);
					}
				);
			}
		);
		
		inputCantidad.keyup(
			function(ev){
				if(ev.which==13)
					$(this).closest(".addOuter").find(".btnConfirmar").click();
			}
		).focus(
			function(){
				var outer = $(this).closest(".addOuter");
				if(outer.closest(".itemEnCarro").size()>0)
					outer.find(".btnConfirmarEdit").show();
			}
		);
		
		//en ficha ocultamos el botn de confirmar cantidad hasta que se modifique la cantidad de nuevo
		jq.find(".btnConfirmarEdit").hide();
	};

	//inicializa la ficha de producto
	function initProducto(jqFichaProducto){
		//tipologias
		jqFichaProducto.find(".bloqueInfo .tip").click(
			function(ev){
				ev.preventDefault();
				ui.catalogo.listado.descripcionTipologia(nbf.extraerDatos($(this)),$(this));
			}
		);
		
		jqFichaProducto.find(".pvpContrastadoDet").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.catalogo.listado.compararPreciosPopup(nbf.extraerDatos(jqFichaProducto),$(this));
			}
		);
		
		//inicializamos controles de carro
		initControlAnadirCarro(
			jqFichaProducto.find(".addOuter"),
			jqFichaProducto,
			function(idProducto,cantidad){
				//actualizamos la ficha
				var item = jqFichaProducto.closest(".fichaProducto");
				ui.catalogo.listado.actualizarCantidadCarroItem(item,cantidad);
				//actualizamos items que pueda haber en listados
				ui.catalogo.listado.actualizarCantidadCarroItem($(".itemsProductos .item"+idProducto+":not(.itemOfertaFlash)"),cantidad);
				ui.pedido.proceso.lista.lanzarActualizarItemsEnCarro();
			}
		);
		
		ui.catalogo.listado.initProductos(jqFichaProducto.find(".prodSimilares .item"));
		
		//eventos de mouse sobre la imagen actual (i-zoom)
		//los enlazamos en medio segundo, por si el usuario tena el ratn sobre la imagen
		nbf.lanzar(
			500,
			function(){
				var cImg = jqFichaProducto.find(".bloqueMedia .imgP");
				cImg.find("img").mouseenter(
					function(ev){
						if(!$(ev.relatedTarget).hasClass("areaCursor"))
							izoomIniciar(cImg);
					}
				).mouseout(
					function(ev){
						if(!$(ev.relatedTarget).hasClass("areaCursor"))
							izoomFinalizar(cImg);
					}
				).mousemove(
					function(ev){
						ev.stopPropagation();
						izoomActualizar(cImg,ev.pageX,ev.pageY);
					}
				).click(
					function(ev){
						ev.stopPropagation();
						var img = $(this);
						if(img.data("urlGrande")){ //solo mostramos popup grande si tiene versin grande
							izoomFinalizar(cImg);
							ui.popup.crearModal(
								"popupImagenProducto",
								function(popup){
									popup.find(".popupContent").css("top",$(window).scrollTop());
									var imgGrande = $("<img />").attr("src",img.data("urlGrande"));
									imgGrande.css("max-width","95%");
									imgGrande.click(
										function(){
											ui.popup.ocultar(popup);
										}
									);
									ui.popup.asignarContenido(popup,imgGrande);
								},
								img
							);
						}
					}
				);
				
				jqFichaProducto.mousemove(
					function(ev){
						izoomFinalizar(cImg);
					}
				);
			}
		);
		
		var urlGrandePrincipal = nbf.extraerDatos(jqFichaProducto.find(".gal li").eq(0));
		var img = jqFichaProducto.find(".bloqueMedia .imgP img");
		img.data("urlGrande",urlGrandePrincipal);
		
		jqFichaProducto.find(".gal li a").click(
			function(ev){
				ev.preventDefault();
				var urlGrande = nbf.extraerDatos($(this).closest("li"));
				cargarImagen(jqFichaProducto,$(this).attr("href"),urlGrande);
			}
		);
		
		jqFichaProducto.find(".btnVArriba").click(
			function(ev){
				ev.preventDefault();
				var popContent = $(this).closest(".popupContent");
				if(popContent.size()>0)
					$(window).scrollTop(popContent.offset().top-80);
				else
					$(window).scrollTop(0);
			}
		);
		
		jqFichaProducto.find(".btnVerSO").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				var idOferta = nbf.extraerDatos($(this));
				ui.fichaOfertaFlash.mostrarPopup(idOferta,$(this));
			}
		);
		
		ui.nbml.init(jqFichaProducto.find(".nbml"));
	};

	//Muestra un popup con el producto pasado
	function mostrarPopup(idProducto,jqAncla){
		if(!idProducto)
			return;
		
		var popupAnterior = $(".popupProducto");
		ui.popup.crearModal(
			"popupProducto",
			function(jqPopup){
				var esVentaCruzada = (jqAncla && jqAncla.closest(".productosVC").size()>0);
				nbf.ejecutar(
					"\\control\\web\\modulo\\ct\\ModuloFichaProducto::ajaxPopupProducto",
					[idProducto,esVentaCruzada,esVentaCruzada?$(".listaCompra .topBusqueda .txt").val():""],
					function(respuesta){
						popupAnterior.remove();
						ui.popup.asignarContenido(jqPopup,respuesta.html);
						//inicializamos el popup
						initProducto(jqPopup.find(".fichaProducto"));
						analytics.trackUrl(respuesta.url);
						/*ui.usuario.consejos.lanzarMostrarConsejoFicha(idProducto);
						//si cerramos popup, ocultamos consejo
						popup.find(".btnCerrar").click(
							function(){
								ui.usuario.consejos.ocultarConsejo();
							}
						);*/
					}
				);
			},
			jqAncla
		);
	};

	nbf.ready(
		function(jq){
			if(jq.is("body")){ //solo en las cargas principales, en popups se carga en la llamada a mostrarPopup
				var modFichaProducto = jq.find(".modFichaProducto");
				//CARGA INICIAL
				if(modFichaProducto.size()>0)
					initProducto(modFichaProducto.find(".fichaProducto"));
			}
		}
	);
	
	return {
		"mostrarPopup":mostrarPopup,
		"initControlAnadirCarro":initControlAnadirCarro
	};
}();