ui = ui || {};
ui.pedido = ui.pedido || {};
ui.pedido.proceso = ui.pedido.proceso || {};
ui.pedido.proceso.carro = function(){
	var jqCarro = null;
	
	function ajustarAltoDespliegue(){
		if(jqCarro.hasClass("carroCompletoDesplegado"))
			jqCarro.find(".despliegueFondo").css("height",ui.alturaMaximaPagina());
	}
	
	//Actualiza el despliegue del carro de compra
	function actualizarDespliegue(funcionOk,esProcesoCompra,esProcesoReservaEntrega){
		var metodo = "\\control\\web\\pedido\\proceso\\carro::ajaxCarroDespliegue";
		var params = [];
		if(esProcesoCompra || esProcesoReservaEntrega){
			metodo = "\\control\\web\\pedido\\proceso\\compra::ajaxProcesoCompra";
			params = [esProcesoReservaEntrega];
		}
		
		nbf.ejecutar(
			metodo,
			params,
			function(respuesta){
				var contenido = $(respuesta);
				jqCarro.find(".despliegueInner").html(contenido);
				initDespliegue(contenido,esProcesoCompra,esProcesoReservaEntrega);
				if(funcionOk)
					funcionOk();
				ajustarAltoDespliegue();
				if(!esProcesoCompra && !esProcesoReservaEntrega)
					analytics.trackUrl("/carro-compra/");
			}
		);
	}
	
	//Traslada un artculo al carro
	function productoACarro(jqImgItem,cantidadAnterior,cantidadNueva,idProducto){
		
		if((cantidadAnterior<cantidadNueva && cantidadNueva>0) || cantidadAnterior>cantidadNueva){
			var img = $("<img />").attr("src",jqImgItem.attr("src")).addClass("imgTransCarro");
			img.css(
				{
					"position":"absolute",
					"z-index":10000
				}
			);
			
			function eliminarImagen(jqImg){
				//gif transparente vaco (para asegurarme que elimino la imagen)
				jqImg.attr("src","data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7");
				jqImg.remove();
			}
			
			//me aseguro que eliminar la imagen
			nbf.lanzar(
				3000,
				function(){
					eliminarImagen($(".imgTransCarro"));
				}
			);
			
			if(cantidadAnterior<cantidadNueva && cantidadNueva>0){ //aadiendo
				var destino = jqCarro.find(".carroResumen .verCarro");
				if(!jqImgItem.offset())
					return;
				
				img.css(
					{
						"left":jqImgItem.offset().left,
						"width":jqImgItem.width(),
						"height":jqImgItem.height(),
						"top":jqImgItem.offset().top
					}
				);
				$("body").append(img);
				
				img.animate(
					{
						"left":destino.offset().left,
						"top":destino.offset().top,
						"width":destino.width(),
						"height":destino.height()
					},
					{
						"duration":1500,
						"complete":function(){
							$(this).fadeOut(
								function(){
									eliminarImagen($(this));
									actualizarResumen();
								}
							);
						}
					}
				);
			}else{ //eliminando
				var btnCarro = jqCarro.find(".carroResumen .verCarro");
				img.css(
					{
						"left":btnCarro.offset().left,
						"top":btnCarro.offset().top,
						"width":btnCarro.width(),
						"opacity":100,
						"z-index":9997
					}
				);
				$("body").append(img);
				
				//buscamos el producto en algn mosaico 
				var imgDest = null;
				if(idProducto){
					//si hay ficha transicionamos hacia all
					imgDest = $(".fichaProducto"+idProducto+" .imgProd");
					if(imgDest.size()==0 && $(".carroCompletoDesplegado").size()==0){ //el carro nunca puede estar desplegado para esta transicin
						if(imgDest.size()==0)
							imgDest = $(".itemsProductosV1 .item"+idProducto+" .imgProd,.items .itemOferFlaMini"+idProducto+" .pL .img .imgProd");
					}
				}
				
				var cssDest = null;
				var duracion = null;
				if(imgDest && imgDest.size()>0 && imgDest.offset()){ //est en mosaico: vuelta a su lugar
					cssDest = {
						"top":imgDest.offset().top,
						"left":imgDest.offset().left,
						"width":imgDest.width(),
						"height":imgDest.height()
					};
					duracion = 1500;
				}else{ //no est en mosaico: salida de carro con fade out
					if(img.offset()){
						img.css("top",img.offset().top-btnCarro.height());
						cssDest = {
							"top":"+=200px",
							"opacity":0
						};
						duracion = 1000;
					}else{
						eliminarImagen(img);
						return;
					}
				}
				
				img.animate(
					cssDest,
					{
						"duration":duracion,
						"complete":function(){
							eliminarImagen($(this));
							actualizarResumen();
						}
					}
				);
			}
		}else //cantidades iguales
			actualizarResumen();
	}
	


	//Inicializa el resumen del carro de compra
	function initResumen(jq){
		if(jq.size()>0){
			jq.click(
				function(ev){
					ev.preventDefault();
					if(jqCarro.hasClass("carroCompletoDesplegado"))
						plegar();
					else if(jqCarro.find(".noProd").size()==0)
						desplegar(false);
				}
			);
			
			jq.find(".btnDesconectar").click(
				function(ev){
					ev.preventDefault();
					ev.stopPropagation();
					usuario.logoff(
						function(url){
							window.location = url;
						}
					);
				}
			);
			
			jq.find(".usr .lnk,.usr .nombre").click(
				function(ev){
					ev.stopPropagation();
				}
			);
			
			jq.find(".btnCom").click(
				function(ev){
					ev.preventDefault();
					ev.stopPropagation();
					if(!jqCarro.hasClass("carroCompletoDesplegado"))
						desplegar(true);
					else{ //si ya est abierto generamos el contenido
						actualizarDespliegue(null,true);
					}
				}
			);
			
			 jq.find(".btnLogin,.btnRegistro,.btnRegLog").click(
				function(ev){
					ev.preventDefault();
					ev.stopPropagation();
					ui.usuario.loginRequerido(
						null,
						function(){
							actualizarResumen();
						},
						null,
						$(this).hasClass("btnRegistro"),
						null,
						$(this)
					);
				}
			);
			
			jq.find(".btnCerrar").click(
				function(ev){
					ev.preventDefault();
					ev.stopPropagation();
					plegar();
				}
			);
		}
	}

	//Inicializa el despliegue del carro de compra
	function initDespliegue(jq,esProcesoCompra,esProcesoReservaEntrega){
		if(jq.size()>0){
			if(esProcesoCompra || esProcesoReservaEntrega){
				ui.pedido.proceso.compra.initProcesoCompra(jq,esProcesoReservaEntrega);
			}else{
				var funcionCambioCantidad = function(item,cantidad){
					var sel = jqCarro.find(".categorias li.sel");
					var posSel = -1;
					if(sel.size()>0)
						posSel = sel.prevAll().size();
					actualizarDespliegue(
						function(){
							actualizarResumen();
							if(posSel>=0)
								jqCarro.find(".categorias > li").eq(posSel).find(".lnkCat").click();
						}
					);
				};
				
				var items = jq.find(".contenido .item");
				if(items.size()>0)
					ui.catalogo.listado.initProductos(items,funcionCambioCantidad);
				
				jq.find(".contenidoVacio .completarLista").click(
					function(ev){
						ev.preventDefault();
						plegar(
							function(){
								ui.pedido.proceso.lista.desplegar(
									function(){
										ui.pedido.proceso.lista.actualizarItems(true);
									}
								);
							}
						);
					}
				);
				
				jqCarro.find(".despliegue .btnPagar a").click(
					function(ev){
						ev.preventDefault();
						desplegar(
							true,
							function(){
								ui.pedido.proceso.compra.pasoSiguiente();
							}
						);
					}
				);
				
				jqCarro.find(".despliegue .btnVaciarCarro").click(
					function(ev){
						ev.preventDefault();
						ui.popup.crearConfirmar(
							"Quieres vaciar tu carro de compra?",
							function(){
								pedido.proceso.carro.eliminarProductos(
									function(){
										actualizarResumen(
											function(){
												plegar();
												ui.pedido.proceso.lista.lanzarActualizarItemsEnCarro();
											}
										);
									}
								);
							},
							null,
							false,
							"Vaciar carrito"
						);
						
					}
				);
				
				ui.usuario.initCodigoPromocional(jqCarro.find(".codDescuentoContenido"));
			}
			jqCarro.find(".despliegueFondo").height(Math.max($("body").height(),jqCarro.height()));
			jqCarro.find(".despliegue .btnPlegar a").click(
				function(ev){
					ev.preventDefault();
					plegar();
				}
			);
		}
	}
	
	nbf.ready(
		function(jq){
			if(jq.is("body")){
				jqCarro = jq.find(".carroCompleto");
				initResumen(jqCarro.find(".carroResumen"));
				
				jqCarro.find(".despliegueFondo").click(
					function(){
						plegar();
					}
				);
			}
		}
	);

	return {
		"actualizarDespliegue":actualizarDespliegue,
		"productoACarro":productoACarro,
		"ajustarAltoDespliegue":ajustarAltoDespliegue
		};
}();

