ui.usuario= ui.usuario|| {};

ui.usuario.direccion = function(){
	//Edita / crea la direccin pasada
	function editar(idDireccion,funcionOk,jqAncla){
		ui.popup.crearModalFormulario(
			"popupEdicionDireccion",
			function(popup){
				nbf.ejecutar(
					"\\appv1\\app::ajaxFormularioEditarDireccion",
					[idDireccion],
					function(respuesta){
						if(respuesta.status=="ok"){
							ui.popup.asignarContenido(popup,respuesta.html);
							
							var fOk = function(){
								usuario.direccion.guardar(
									idDireccion,
									ui.form.obtenerValores(popup.find("form")),
									function(id){
										ui.popup.ocultar(popup);
										if(funcionOk)
											funcionOk(id);
									},
									function(mensajes){
										ui.popup.crearAlertaError(mensajes,null,"Error en la direccin");
									}
								);
							};
							var fCancel =function(){
								ui.popup.ocultar(popup);
								ui.usuario.direccion.actualizar(jqAncla);
							}
							
							popup.find("form").submit(
								function(ev){
									ev.preventDefault();
									fOk();
								}
							);
							
							popup.find(".guardar").click(
								function(ev){
									ev.preventDefault();
									ev.stopPropagation();
									fOk();
								}
							);
							popup.find(".cancelar").click(
								function(ev){
									ev.preventDefault();
									ev.stopPropagation();
									fCancel();
								}
							);
							
							ui.codigoPostalLocalidad(popup.find(".codigoPostalLocalidad"));
						}else
							ui.popup.crearAlertaAdvertencia(nbf.txt.v("SESION_CADUCADA"));
					}
				);
			},
			jqAncla,
			true,
			"Aadir direccin"
		);
	}

	//actualiza la lista de direcciones
	function actualizar(jq,funcionOk){
		nbf.ejecutar(
			"\\appv1\\app::ajaxDireccionesEntrega",
			[],
			function(respuesta){
				if(respuesta.status=="ok"){
					$(".seccionPrincipal").css("display","block");
					$("body").css("overflow","hidden");
					//alert(respuesta.html);
					var contenido =$(".pasoCompraContenido");
					contenido.html(respuesta.html);
					//jq.replaceWith(contenido);
					init(contenido);
					
					
					if(funcionOk)
						funcionOk();
				}else
					ui.popup.crearAlertaAdvertencia(nbf.txt.v("SESION_CADUCADA"));
			}
		);
	}
	

	//inicializa bloque de direcciones
	function init(jq){
		jq.find(".btnAdd").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				ui.usuario.direccion.editar(
					null,
					function(id){
						ui.usuario.direccion.actualizar(jq);
					},
					$(this)
				);
			}
		);
		$(".btnOk").click(
			function(){
//				alert("foooocucs");
			}
		);
		
		jq.find(".btnEdit").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				var li = $(this).closest("li");
				var idDireccion = nbf.extraerDatos(li);
				ui.usuario.direccion.editar(
					idDireccion,
					function(){
						ui.usuario.direccion.actualizar(jq);
					},
					li
				);
			}
		);
		
		jq.find(".btnEliminar").click(
			function(ev){
				ev.preventDefault();
				ev.stopPropagation();
				var idDireccion = nbf.extraerDatos($(this).closest("li"));
				ui.popup.crearConfirmar(
					"Ests seguro que quieres eliminar la direccin?", 
					function(){
						usuario.direccion.eliminar(
							idDireccion,
							function(){
								ui.usuario.direccion.actualizar(jq);
							},
							function(mensajes){
								ui.popup.crearAlertaError(mensajes,null,"Error en la eliminacin");
							}
						);
					},
					null,
					false,
					"Eliminar direccin"
				);
			}
		);
		
		var procesoCompra = jq.closest(".procesoCompra"); 
		if(procesoCompra.size()>0){
			var lisSel = jq.find("li.sel"); 
			
			lisSel.click(
				function(ev){
					ev.preventDefault();
					ev.stopPropagation();
					ui.vibracionCorta();
					var li = $(this);
					if(!li.hasClass("selCheck")){
						var idDireccion = nbf.extraerDatos(li);
						pedido.proceso.compra.seleccionarDireccionEntrega(
							idDireccion,
							function(){
								li.closest("ul").find("li").removeClass("selCheck");
								li.addClass("selCheck");
							}
						);
					}
				}
			).hover(
				function(){
					$(this).addClass("hover");
				},
				function(){
					$(this).removeClass("hover");
				}
			);
			
			//comprobamos si solo hay una direccin y la seleccionamos
			if(lisSel.size()==1)
				lisSel.click();
		}
	}

	nbf.ready(
		function(jq){
			if(jq.is("body")){
				var modConsultaCp = jq.find(".modConsultaCodigoPostal");
				if(modConsultaCp.size()>0){
					var form = modConsultaCp.find("form");
					var campoCP = form.find("input[name=codigoPostal]");
					form.submit(
						function(ev){
							ev.preventDefault();
							usuario.comprobarCodigoPostal(
								campoCP.val(),
								function(valido){
									var bloque = modConsultaCp.find(".bloque");
									if(valido)
										bloque.addClass("valido");
									else
										bloque.addClass("noValido");
									campoCP.blur();
								}
							);
						}
					);
					campoCP.focus(
						function(){
							$(this).val("");
							modConsultaCp.find(".bloque").removeClass("valido noValido");
						}
					);
					modConsultaCp.find(".btnRegistro").click(
						function(ev){
							ev.preventDefault();
							ui.usuario.loginRequerido(null,null,null,true,modConsultaCp.find("input[name=codigoPostal]").val(),$(this));
						}
					);
					modConsultaCp.find(".btnProbarOtro").click(
						function(ev){
							ev.preventDefault();
							modConsultaCp.find(".bloque").removeClass("valido noValido");
						}
					);
				}
			}
		}
	);
	
	return {
		"actualizar":actualizar,
		"editar":editar,
		"init":init
	};
}();