var usuario = function(){
	var esPro = (window.location.href.indexOf("www.tudespensa.com")>-1);
	
	//Cambia los datos personales del usuario
	function cambiarDatosPersonales(esEmpresa,datos,funcionOk,funcionError){
		nbf.ejecutar(
			"\\appv1\\app::ajaxCambiarDatosPersonales",
			[esEmpresa,datos],
			function(respuesta){
				if(respuesta.status=="ok"){
					if(funcionOk)
						funcionOk();
				}else{
					if(funcionError)
						funcionError(respuesta.mensajes);
				}		
			}
		);
	}

	//Cambia el e-mail del usuario
	function cambiarEmail(nuevoEmail,nuevoEmailConfirmar,funcionOk,funcionError,desdePedido){
		nbf.ejecutar(
				"\\appv1\\app::ajaxCambiarEmail",
			[nuevoEmail,nuevoEmailConfirmar,desdePedido],
			function(respuesta){
				if(respuesta.status=="ok"){
					if(funcionOk)
						funcionOk();
				}else{
					if(funcionError)
						funcionError(respuesta.mensajes);
				}
			}
		);
	}

	//Cambia a empresa o particular
	function cambiarEsEmpresa(esEmpresa,funcionOk,funcionError){
		nbf.ejecutar(
			"\\appv1\\app::ajaxCambiarEsEmpresa",
			[esEmpresa],
			function(respuesta){
				if(respuesta.status=="ok"){
					if(funcionOk)
						funcionOk();
				}else{
					if(funcionError)
						funcionError(respuesta.mensajes);
				}
			}
		);
	}

	//Cambia el pass del usuario
	function cambiarPass(anteriorPass,nuevoPass,nuevoPassConfirmar,funcionOk,funcionError){
		nbf.ejecutar(
				"\\appv1\\app::ajaxCambiarPass",
			[anteriorPass,nuevoPass,nuevoPassConfirmar],
			function(respuesta){
				if(respuesta.status=="ok"){
					if(funcionOk)
						funcionOk();
				}else{
					if(funcionError)
						funcionError(respuesta.mensajes);
				}
			}
		);
	}
	
	//Comprueba el cdigo postal pasado y llama a funcionOk pasndole si es vlido o no
	function comprobarCodigoPostal(codigoPostal,funcionOk,funcionError){
		nbf.ejecutar(
			"\\control\\web\\modulo\\ct\\ModuloConsultaCodigoPostal::ajaxConsultaCodigoPostal",
			[codigoPostal],
			function(respuesta){
				if(respuesta.status=="ok"){
					funcionOk(respuesta.valido);
				}else{
					if(funcionError)
						funcionError(respuesta.mensajes);
					else
						ui.popup.crearAlertaError(respuesta.mensajes,null,"");
				}
			}
		);
	}

	//Solicita que se restablezca el pass del email pasado
	function restablecerPassSolicitar(email,funcionOk,funcionError){
		nbf.ejecutar(
			"\\datos\\usuario\\usuarios::ajaxRestablecerPassSolicitar",
			[email],
			function(respuesta){
				if(respuesta.status=="ok"){
					if(funcionOk)
						funcionOk();
				}else{
					if(funcionError)
						funcionError(respuesta.mensajes);
				}	
			}
		);
	};

	//Envia una recomendacin a las direcciones de e-mail y con el mensaje personalizado 
	function enviarRecomendacion(datos,funcionOk,funcionError,idModulo){
		nbf.ejecutar(
			"\\datos\\usuario\\usuarios::ajaxEnviarRecomendacion",
			[datos],
			function(respuesta){
				if(respuesta.status=="ok"){
					if(funcionOk)
						funcionOk();
				}else{
					if(funcionError)
						funcionError(respuesta.mensajes);
				}
			}
		);
	};
	
	//Procesa las acciones de regla de gestin que estn encoladas en la respuesta y devuelve true/false si se ha procesado alguna
	function procesarAccionesReglaGestion(respuesta,funcionOk){
		var ret = false;
		if(respuesta && respuesta.accionesReglaGestion){
			var accs = respuesta.accionesReglaGestion;
			for(var i=0;i<accs.length;i++){
				switch(accs[i].tipo){
					case "redirigir":
						ret = true;
					break;
					case "mensajeEmergente":
						if(accs[i].datos.idPlantilla){
							if(accs[i].datos.textoAlternativo){
								ui.popup.crearAlertaOk(
									accs[i].datos.textoAlternativo,
									function(){
										if(funcionOk)
											funcionOk();
									},
									""
								);
							}
						}
						else
							ui.popup.crearAlertaOk(
								accs[i].datos.mensaje,
								function(){
									if(funcionOk)
										funcionOk();
								},
								""
							);
						ret = true;
					break;
				}
			}
		}
		if(ret==false){
			if(funcionOk)
				funcionOk();
		}
		return ret;
		
	};
	
	return {
		"esPro":esPro,
		"cambiarDatosPersonales":cambiarDatosPersonales,
		"cambiarEmail":cambiarEmail,
		"cambiarEsEmpresa":cambiarEsEmpresa,
		"cambiarPass":cambiarPass,
		"comprobarCodigoPostal":comprobarCodigoPostal,
		"restablecerPassSolicitar":restablecerPassSolicitar,
		"enviarRecomendacion":enviarRecomendacion,
		"procesarAccionesReglaGestion":procesarAccionesReglaGestion
	};
}();
