//libreras para uso de storage con caducidad de tiempo
var st = {};

st.eliminarSesionVar = function(nombre){
	return st.eliminarLocalVar(nombre);
}

/**
 * funciones para uso de Storage con expiracion para simular la sesion del navegador
 * @param name
 * @returns
 */
st.eliminarLocalVar = function (nombre) {
    localStorage.removeItem(nombre);
    localStorage.removeItem(nombre+'_time');
};

/**
 * Establece un valor en el localStorage
 */
st.establecerLocalVar = function (nombre, valor, expira) {
    if (expira==undefined || expira=='null') { 
    	//var expira= 3600;// default: 1h
    	var expira ='never';
    } 
    var date = new Date();
    var fecha="";
    if(expira=='never')
    	fecha="never";
    else
       	fecha = Math.round((date.setSeconds(date.getSeconds()+expira))/1000);
    
    localStorage.setItem(nombre, valor);
    localStorage.setItem(nombre+'_time', fecha);
};
/**
 * Creamos esta funcion para llamar a la de establecerlocalvar con tiempo 1hora de expiracion
 */
st.establecerSesionVar =function(nombre,valor){
	return st.establecerLocalVar(nombre,valor,'null');
}
st.estadoSesionVar = function(nombre){
	return st.estadoLocalVar(nombre);
}

/** 
 * Comprueba el estado de la variable localStorage
 */
st.estadoLocalVar = function (nombre) {
    var date = new Date();
    var fechaActual = Math.round(+date/1000);
    // Get Schedule
    var fechaAlmacenada = localStorage.getItem(nombre+'_time');
    if(fechaAlmacenada=='never'){
    	
    	return 1;
    }
    if (fechaAlmacenada==undefined || fechaAlmacenada=='null') { var fechaAlmacenada = 0; }
    // Expired
    if (fechaAlmacenada < fechaActual) {
        // Remove
        st.eliminarLocalVar(nombre);
        return 0;
    } else {
        return 1;
    }
};

st.obtenerSesionVar = function(nombre){
	if(st.estadoSesionVar(nombre)==1)
		return st.obtenerLocalVar(nombre);
	else
		return "";
}
/** 
 * Devuelve el valor de una variable localStorage si no ha expirado
 */
st.obtenerLocalVar = function (nombre){
	if(st.estadoLocalVar(nombre)==1)
		return localStorage.getItem(nombre);
	else
		return "";
	
}